/** \file
 * Hello world example app.
 * A very simple mpi skeleton application.
 */

#include <sstmac/software/libraries/mpi/mpiapp.h>



/// A hello world example mpi skeleton application.
namespace hellocomm {
 
  /** Helloapp is an example mpi skeleton application.  It inherits mpi 
    * support [things like mpiapi()] from mpiapp.  mpiapp is derived from
    * the thread class, so this will be a runnable task thread [it must
    * implement a run() method].
    */

  class helloapp : public sstmac::sw::mpiapp {

  protected:
    
    std::string message_;

    /** Protected constructor, public uses helloapp::construct(). */
    helloapp(sstmac::sw::softwareid id): mpiapp(id) {};

  public:
    typedef boost::intrusive_ptr<helloapp> ptr;

    /** Public constructor, creates a reference counted app object. */
    static ptr construct(sstmac::sw::softwareid id);

    /** Get a copy, launchers can use this to create app threads. */
    sstmac::sw::app::ptr clone(sstmac::sw::softwareid id);

    /** Destructor. */
    virtual ~helloapp() throw() {};

    /** The main routine for the skeleton application. */
    void skeleton_main();
    
    /** Process the argument list. */
    void consume_params(const sstmac::sim_parameters::ptr &params);
  };

} // end of namespace hellocomm

