/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/backends/native/components/nic/networkinterface.h>

namespace sstmac { namespace native
  {

  debug networkinterface::dbg_;

  networkinterface::map_type networkinterface::node_map_;

  networkinterface::networkinterface(const node::ptr &parent,
      const sstmac::hw::interconnect::ptr &interconn) :
      interconn_(interconn), parent_(parent)
  {
    if(!dbg_.is_real()){
        dbg_ = debug("<debug> nic");
        logger::register_logger(&dbg_);
    }
  }

  networkinterface::~networkinterface()
  {
  }

  void networkinterface::set_node_map(nodeid::ptr id, const networkinterface::ptr &n)
  {
    node_map_[id] = n;
  }


  } } // end of namespace sstmac.
