/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_NATIVE_MANAGERDEGRADED_H_
#define SSTMAC_BACKENDS_NATIVE_MANAGERDEGRADED_H_

#include <sstmac/backends/native/manager.h>

namespace sstmac { namespace native {

class manager_degraded : public manager
{
protected:
  manager_degraded() {}

public:
  typedef boost::intrusive_ptr<manager_degraded> ptr;

  virtual
  ~manager_degraded() throw() {};

  virtual long
     add_nodes(sim_parameters::ptr params);

  static ptr
    construct(){
    return ptr(new manager_degraded());
  }

};
} }

#endif /* MANAGERDEGRADED_H_ */
