/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_NIC_FLOWNIC_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_NIC_FLOWNIC_H_INCLUDED

#include <omnetpp.h>

#include <node_m.h>

#include "nic.h"

namespace sstmac { namespace omnetpp {

#define GUARD_TIME 1E-9


  class flownic: public nic {
  protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    virtual void finish();

    void try_net_Q();
    //void send_proc_ack(ApplicationMsg* coreMsg);

    cGate* fromProc;
    cGate* toProc;
    cGate* fromNet;
    cGate* toNet;

    double networkFlowBW;
    double memoryFlowBW;
    double effectiveBW;

    bool currentlyTransmitting;

    cPacketQueue netQ;

    int flowid;

    cMessage* guardMsg;

  };
} }
#endif
