/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_CORE_CORE_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_CORE_CORE_H_INCLUDED
/*
#include <omnetpp.h>


#include "SSTSF/AMI/environment.h"

//#include "Application.h"
//#include "API.h"

#include "systemspace.h"
#include "Address.h"
#include "node_m.h"

#include "Util/debug_sstmedium.h"

#include "resourceallocator.h"

#include "Indexer.h"

#include "SSTSF/Process/operatingsystem.h"
#include "SSTSF/AMI/AMI.h"
#include "SSTSF/Messages/sst_message.h"
#include "SSTSF/Process/softwareid.h"

#include <sstmac/common/ptr_type.h>

#include <queue>

//class Application;

#define APP_STACK_SIZE 16384

#define OS_MSG_HEADER_SIZE 8
#define APP_SIZE 1000

#define APP_START_DELAY 0.00001

#define SEND_DELAY 0.00001

class LaunchInfo
{
public:
  std::string appname;

  // these params are different for different programming models?
  // for MPI, param1 = rank.
  int param1;
  int param2;
  int param3;
};




class Core : public cSimpleModule, public sstmac::sw::AMI
{
public:
  Core();
  virtual
  ~Core();

  //void
  //processSignal(CoreSignal* sig);

  //virtual bool is_master_core();

  Address
  getAddr()
  {
    return myid;
  }



protected:

  virtual void
  handleMessage(cMessage* cmg);
  virtual void
  initialize();
  virtual void
  finish();

  virtual bool
  launch_app(Indexer* ind, Space* sp, std::string appname, int appid,
      int appsize);
  virtual void
  instantiate_app(Indexer* appind, std::string appname, sstmac::sw::softwareid id);

  virtual void
  instantiate_allocator(string allocName);

  virtual void
  instantiate_indexer(Space* appspace, int appid);

  virtual Space*
  instantiate_space(string spacename, int spaceparam1, int spaceparam2);

  bool is_master_core();

  Address myid;
  int coresPerProc, procsPerNode, numOfNodes;
  int nodesPerRack;
  int numRacks;

  //cMessage* computeMsg;
  cMessage* newAppMsg;
  cMessage* appStartMsg;

  cGate* outgate;
  cGate* ingate;

  resourceallocator* allocator;

  //launching stuff
  int nextApp;
  map<int, string> appNames;
  map<int, double> appStartTimes;
  map<int, int> appSizes;
  map<int, list<string>* > appStringParams;

  map<int, Indexer*> appIndexers;

  //Application* app;

  boost::shared_ptr<sstmac::sw::operatingsystem> opsys;

  //map<int, API*> apis;
  //Space* appspace;

  //string app1Param1;

  //string app2Param1;

  debug_sstmedium dbg;

  static map<sstmac::sw::appid, sstmac::sw::environment::ptr > env_;



  // --- sstmac::sw::AMI pure virtuals ---- //
  virtual void
  executeKernel(int func, boost::shared_ptr<sstmac::sw::sst_message> data);

  virtual bool
  kernelSupported(int func);

  virtual timestamp now();
  // ------------------------------------ //


  //scheduling
  map<cMessage*, boost::shared_ptr<sstmac::sw::sst_message> > computeMessages;
  queue<boost::shared_ptr<sstmac::sw::sst_message> > suspendedQ;

};
*/
#endif
