/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include "environmentpod.h"

//#include "SSTSF/Messages/valuepayload.h"

#include "medium_serializer.h"

namespace sstmac { namespace omnetpp {


  environmentpod::~environmentpod()
  {

  }

  void
  doPacking(cCommBuffer *buffer, environmentpod& load)
  {

    medium_serializer *sst_buff = new medium_serializer(buffer);
    load.load->serialize(sst_buff);

  }

  void
  doUnpacking(cCommBuffer *buffer, environmentpod& load)
  {

    medium_serializer *sst_buff = new medium_serializer(buffer);

    load = environmentpod(sstmac::sw::environment::deserialize(sst_buff));

  }

} }
