/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_NOC_DUMMYNOCMODEL_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_NOC_DUMMYNOCMODEL_H_INCLUDED

#include <omnetpp.h>

#include <map>

namespace sstmac { namespace omnetpp {


  using namespace std;

  class dummynocmodel: public cSimpleModule {
  public:
    dummynocmodel();
    virtual ~dummynocmodel();

  protected:
    void handleMessage(cMessage* cmsg);
    void initialize();

    map<int, cGate*> fromProc;
    map<int, cGate*> toProc;
    map<int, cGate*> toNetwork;
    map<int, cGate*> fromNetwork;
    map<int, cGate*> toStorage;
    map<int, cGate*> fromStorage;

    double nocDelay;

  };
} }
#endif
