/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/common/nocopy.h>
#include <sstmac/common/errors.h>

namespace sstmac {


  //
  // Default construction is ok.
  //
  nocopy::nocopy() {
  }

  //
  // Goodbye.
  //
  nocopy::~nocopy() {
  }

  //
  // error.
  //
  nocopy::nocopy(const nocopy&) {
    throw illformederror("nocopy:  Illegal call to copy constructor.");
  }

  //
  // error.
  //
  nocopy& nocopy::operator=(const nocopy&) {
    throw illformederror("nocopy:  Illegal call to assignment operator.");
  }


} // end of namespace sstmac
