/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef MEMORYMODEL_H_
#define MEMORYMODEL_H_

#include <sstmac/common/eventmodule.h>

namespace sstmac { namespace hw
{

  class memorymodel : public eventmodule
  {
  protected:
    memorymodel();

    static debug dbg_;

  public:
    typedef boost::intrusive_ptr<memorymodel> ptr;

    virtual
    ~memorymodel();

    virtual void do_access(sst_message::ptr msg) = 0;


  };

} } /* namespace sstmac */
#endif /* MEMORYMODEL_H_ */
