/*
 * simple_memorymodel.cc
 *
 *  Created on: Nov 2, 2011
 *      Author: ghendry
 */

#include <sstmac/hardware/memory/simple_memorymodel.h>

namespace sstmac
{
  namespace hw
  {

    simple_memorymodel::simple_memorymodel(double mem_bw, timestamp mem_lat, eventhandler::ptr whendone) :
        mem_bw_(mem_bw), mem_lat_(mem_lat), current_accesses_(0), done_(whendone)
    {
      self_ = ptr(this);
    }

    simple_memorymodel::~simple_memorymodel()
    {
      // TODO Auto-generated destructor stub
    }

    void
    simple_memorymodel::handle(const sst_message::ptr &msg)
    {
      current_accesses_--;

      done_->handle(msg);
    }

    void
    simple_memorymodel::do_access(sst_message::ptr msg)
    {
      current_accesses_++;

      SSTMAC_DEBUG << "simple_memorymodel: doing access of " << msg->get_byte_length() << " with " << current_accesses_ << " current accesses \n";


      timestamp done = mem_lat_ + timestamp(msg->get_byte_length() * (current_accesses_ / mem_bw_));
      schedule(now() + done, self_, msg);
    }

  }
} /* namespace sstmac */
