/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMFACTORY_PENDING_KEYLIST_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMFACTORY_PENDING_KEYLIST_H_INCLUDED

#include <sstmac/common/ptr_type.h>
#include <sstmac/software/libraries/mpi/mpi_comm/mpicommfactory-pending.h>

namespace sstmac { namespace sw
{

  ////
  //// Manage state for MPI_Comm_split.  Each instance of this type
  //// corresponds to a given color.
  ////
 /* class mpicommfactory::pending_split::keylist : public ptr_type
  {
    /// This is how we store the location of each rank.
    struct location
    {
      location() :
        the_task(-1),
        ////the_node(-1),
            final_rank(-1)
      {
      }
      location(const taskid &tid////, const nodeid &nid
      ) :
        the_task(tid)////, the_node(nid)
      {
      }
      taskid the_task;
      ////nodeid the_node;
      /// This rank gets populated on first call to get_mpicomm,
      /// after which the list is locked.
      mpiid final_rank;
    };

    /// The nodes (keys) encountered so far.
    /// The keylist is complete whenever the ranks are densely populated
    /// from zero to size-1.
    typedef std::map<int, location> rankmap_t;
    rankmap_t ranks_;

    /// The communicator id.
    mpicommid id_;

    /// When get_mpicomm is called the first time, this shared state
    /// gets constructed.  After that, no more nodes can be inserted.
    mpicommdata::ptr shared_;

  protected:
    /// Hello.
    keylist(const mpicommid &id);

  public:
    typedef boost::intrusive_ptr<mpicommfactory::pending_split::keylist> ptr;

    /// Goodbye.
    virtual
    ~keylist();

    /// Construct a new keylist.
    static keylist::ptr
    construct(const mpicommid &id);

    /// Return true if no ranks have been added yet.
    bool
    empty() const;

    /// Return true if shared state has been constructed (no more insert
    /// calls can be made).
    bool
    locked() const;

    /// Test whether the given rank is already defined in the keylist.
    /// Returns true for negative keys (since they correspond to comm_null).
    bool
    contains(int key) const;

    /// Insert a new rank in the keylist.
    /// \throw illformederror if(this->locked() == true).
    /// \throw valueerror if(key >= 0 && contains(key) == true).
    void
    insert(int key, const taskid &tid, nodeaddress::ptr &nid);

    /// Get a communicator corresponding to the given key.
    /// Locks the keylist (locked() will return false after this call).
    /// \throw uninitializederror if(key >= 0 && contains(key) == false).
    /// \throw valueerror if the key is not defined in the keylist.
    mpicomm
    get_mpicomm(int key);
  };
*/
} } // end of namespace sstmac.

#endif
