/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/process/app.h>

namespace sstmac {
namespace sw {
void app::compute(timestamp time) {

	if (!computetime_) {
		computetime_ = lib_compute_time::construct(id_);
		register_lib(computetime_);
	}
	computetime_->compute(time);
}

void app::compute_inst(const eventdata::ptr &cmsg) {
	if (!computeinst_) {
		computeinst_ = lib_compute_inst::construct(id_);
		register_lib(computeinst_);
	}
	computeinst_->compute_inst(cmsg);
}

void app::sleep(timestamp time) {
	if (!sleeplib_) {
		sleeplib_ = lib_sleep::construct(id_);
		register_lib(sleeplib_);
	}
	sleeplib_->sleep(time);
}

}
}
