/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_SKELETONS_TEST_MPIPINGPONG_H_INCLUDED
#define SSTMAC_SOFTWARE_SKELETONS_TEST_MPIPINGPONG_H_INCLUDED

#include <sstmac/software/libraries/mpi/mpiapp.h>

namespace sstmac { namespace sw
{

  /**
   * Basic MPI ping-pong.
   */
  class mpipingpong : public mpiapp
  {
    /// How many iterations we do.
    int iterations_, count_;

  protected:
    /// Hi.
    mpipingpong(softwareid id) : mpiapp(id)
    {
    }

  public:
    typedef boost::intrusive_ptr<mpipingpong> ptr;

    /// Hello.
    static mpipingpong::ptr
    construct(softwareid id);



    /// Goodbye.
    virtual
    ~mpipingpong() throw ();

    /// Get a copy.
    virtual app::ptr
    clone(softwareid id);

    /// Go.
    void
    skeleton_main();

    virtual void
    consume_params(const sim_parameters::ptr &params);
  };

} } // end of namespace sstmac

#endif
