/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/skeletons/test/test_compute.h>

namespace sstmac { namespace sw
{
  using namespace std;
  

  test_compute::test_compute(softwareid id) :
    app(id)
  {


  }

  // Build a new minimd object.
  //
  test_compute::ptr
  test_compute::construct(softwareid id)
  {
    test_compute::ptr retval(new test_compute(id));
    // retval->set_self(retval);
    return retval;
  }

  void
  test_compute::consume_params(const sim_parameters::ptr &params)
  {

    numIterations_ = params->get_int_param("testcompute_iterations");
  }

  //
  // Get a copy of this object.
  //
  app::ptr
  test_compute::clone(softwareid id)
  {
    return construct(id);
  }

  test_compute::~test_compute()
  {

  }

  void
  test_compute::skeleton_main()
  {
    SSTMAC_DEBUG<< "t=" << now() << ": Hello World, i'm computer number " << id_.task_.id << ", about to begin "
          << numIterations_ << " computations! \n";


    for(int i = 0; i < numIterations_; i++){
        timestamp t(rand() % 100);
        compute(t);
    }

  }

} } //end of namespace sstmac
